haskore-0.2.0.3: The Haskore Computer Music System

Safe Haskell | Safe-Inferred

Haskore.Interface.CSound.Orchestra

# Documentation

data Output out => T out Source

Constructors

Cons Header [InstrBlock out] |

Instances

Output out => Eq (T out) |
Output out => Show (T out) |

data InstrBlock a Source

Constructors

InstrBlock |

Fields

instrBlockInstr :: Instrument
instrBlockReverb :: Reverb
instrBlockOutput :: a
instrBlockGlobals :: [(GlobalSig, SigExp)]

Instances

Eq a => Eq (InstrBlock a) |
Show a => Show (InstrBlock a) |

type Header = (AudRate, CtrlRate)Source

type AudRate = Int Source

type CtrlRate = Int Source

type SigExp = T SigTermSource

type DelayLine = DelayLineTerm SigExp Source

type Boolean = BooleanTerm SigExp Source

data GlobalSig Source

Constructors

Global EvalRate (SigExp -> SigExp -> SigExp) Int |

Instances

Eq GlobalSig |
Show GlobalSig |

class (Show c, Eq c) => Output c where Source

Methods

getChannels :: c -> [SigExp]Source

getName :: c -> String Source

getChannelCount :: c -> Int Source

Instances

Output Quad |
Output Stereo |
Output Mono |

data Mono Source

Constructors

Mono SigExp |

Instances

Eq Mono |
Show Mono |
Output Mono |

data Stereo Source

Constructors

Stereo SigExp SigExp |

Instances

Eq Stereo |
Show Stereo |
Output Stereo |

data Quad Source

Constructors

Quad SigExp SigExp SigExp SigExp |

Instances

Eq Quad |
Show Quad |
Output Quad |

data EvalRate Source

Constructors

NR |
CR |
AR |

Instances

Eq EvalRate |
Ord EvalRate |
Show EvalRate |

data Instrument Source

Instances

Eq Instrument |
Show Instrument |

type Name = String Source

sigGen :: Function -> EvalRate -> OutCount -> [SigExp] -> SigExp Source

tableNumber :: Table -> SigExp Source

readGlobal :: GlobalSig -> SigExp Source

rec :: (SigExp -> SigExp) -> SigExp Source

toString :: Output a => T a -> String Source

saveIA :: Output a => T a -> IO ()Source

save :: Output a => FilePath -> T a -> IO ()Source

channelCount :: Output a => T a -> Int Source

getMultipleOutputs :: SigExp -> [SigExp]Source

noteDur :: SigExp Source

notePit :: SigExp Source

noteVel :: SigExp Source

p1 :: SigExp Source

p2 :: SigExp Source

p3 :: SigExp Source

p4 :: SigExp Source

p5 :: SigExp Source

p6 :: SigExp Source

p7 :: SigExp Source

p8 :: SigExp Source

p9 :: SigExp Source

pField :: Int -> SigExp Source

(<*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(<=*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(>*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(>=*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(==*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(/=*) :: TreeTerm term => T term -> T term -> BooleanTerm (T term)Source

(&&*) :: Boolean -> Boolean -> Boolean Source

(||*) :: Boolean -> Boolean -> Boolean Source

ifthen :: TreeTerm term => BooleanTerm (T term) -> T term -> T term -> T termSource

constInt :: Int -> SigExp Source

constFloat :: Float -> SigExp Source

constEnum :: Enum a => a -> SigExp Source

pchToHz :: SigExp -> SigExp Source

dbToAmp :: SigExp -> SigExp Source

line :: EvalRate -> SigExp -> SigExp -> SigExp -> SigExp Source

expon :: EvalRate -> SigExp -> SigExp -> SigExp -> SigExp Source

lineSeg :: EvalRate -> SigExp -> SigExp -> SigExp -> [(SigExp, SigExp)] -> SigExp Source

exponSeg :: EvalRate -> SigExp -> SigExp -> SigExp -> [(SigExp, SigExp)] -> SigExp Source

env :: EvalRate -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp Source

phasor :: EvalRate -> SigExp -> SigExp -> SigExp Source

data IndexMode Source

Constructors

RawIndex |
NormalIndex |

Instances

Enum IndexMode |
Eq IndexMode |
Show IndexMode |

tblLookup :: EvalRate -> IndexMode -> SigExp -> SigExp -> SigExp Source

tblLookupI :: EvalRate -> IndexMode -> SigExp -> SigExp -> SigExp Source

osc :: EvalRate -> SigExp -> SigExp -> SigExp -> SigExp Source

oscI :: EvalRate -> SigExp -> SigExp -> SigExp -> SigExp Source

fmOsc :: SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp Source

fmOscI :: SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp Source

sampOsc :: SigExp -> SigExp -> SigExp -> SigExp Source

random :: EvalRate -> SigExp -> SigExp Source

randomH :: EvalRate -> SigExp -> SigExp -> SigExp Source

randomI :: EvalRate -> SigExp -> SigExp -> SigExp Source

genBuzz :: SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp -> SigExp Source

buzz :: SigExp -> SigExp -> SigExp -> SigExp -> SigExp Source

pluck :: SigExp -> SigExp -> PluckDecayMethod -> SigExp -> SigExp -> SigExp Source

data PluckDecayMethod Source

Constructors

PluckSimpleSmooth |
PluckStretchSmooth SigExp |
PluckSimpleDrum SigExp |
PluckStretchDrum SigExp SigExp |
PluckWeightedSmooth SigExp SigExp |
PluckFilterSmooth |

delay :: SigExp -> SigExp -> SigExp Source

vdelay :: SigExp -> SigExp -> SigExp -> SigExp Source

comb :: SigExp -> SigExp -> SigExp -> SigExp Source

alpass :: SigExp -> SigExp -> SigExp -> SigExp Source

reverb :: SigExp -> SigExp -> SigExp Source

delTap :: DelayLine -> SigExp -> SigExp Source

delTapI :: DelayLine -> SigExp -> SigExp Source

type Orc a b = State (OrcState a) bSource

mkSignal :: Output a => EvalRate -> (SigExp -> SigExp -> SigExp) -> Orc a GlobalSig Source

addInstr :: Output a => InstrBlock a -> Orc a ()Source

mkOrc :: Output a => Header -> Orc a () -> T aSource

orc1 :: T Stereo Source

test :: IO ()Source

test1 :: StatementDefsSource